com.ihr.xbrl.mapper.instance

## Interface MapperPeriod

- All Superinterfaces:
    java.lang.Cloneable
  All Known Implementing Classes:
    MapperPeriod2, MapperPeriod3, MapperPeriodBase

      public interface MapperPeriod
      extends java.lang.Cloneable

  The Interface MapperPeriod.
  Author:
    Ignacio

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `MapperPeriod` | `clone()` Clone.
    `boolean` | `equals(java.lang.Object other)` Equals.
    `org.jdom.Element` | `generateNode(boolean relativize, java.net.URI base)` Generate node.
    `java.lang.String` | `getDate(int type, boolean operate)` Gets the date.
    `java.util.Iterator<XMLFragment>` | `getElements()` Gets the elements.
    `java.util.GregorianCalendar` | `getGregorianCalendarDate(int type)` Gets the gregorian calendar date.
    `XBRLItem.PeriodType` | `getPeriodType()` Gets the period type.
    `java.lang.String` | `getRawDate(int type, boolean operate)` Gets the raw date.
    `java.util.Date` | `getRawDateUtil(int code)` Gets the raw date util.
    `java.util.GregorianCalendar` | `getRawGregorianCalendarDate(int type)` Gets the raw gregorian calendar date.
    `XBRLPeriod` | `getXBRLPeriod()` Gets the XBRL period.
    `int` | `hashCode()` Hash code.
    `boolean` | `isDuration()` Checks if is duration.
    `boolean` | `isForever()` Checks if is forever.
    `boolean` | `isInstant()` Checks if is instant.
    `boolean` | `isMacroPeriod()` Checks if is macro period.
    `void` | `setDate(int type, java.lang.String strDate)` Sets the date.
    `java.lang.String` | `toString()` To string.

- - ### Method Detail

    - #### getXBRLPeriod

          XBRLPeriod getXBRLPeriod()

      Gets the XBRL period.
      Returns:
        the XBRL period

    - #### isForever

          boolean isForever()

      Checks if is forever.
      Returns:
        true, if is forever

    - #### isInstant

          boolean isInstant()

      Checks if is instant.
      Returns:
        true, if is instant

    - #### isDuration

          boolean isDuration()

      Checks if is duration.
      Returns:
        true, if is duration

    - #### isMacroPeriod

          boolean isMacroPeriod()

      Checks if is macro period.
      Returns:
        true, if is macro period

    - #### setDate

          void setDate(int type,
                     java.lang.String strDate)
                       throws XBRLValidationException

      Sets the date.
      Parameters:
        `type` - the type
        `strDate` - the str date
      Throws:
        `XBRLValidationException` - the XBRL validation exception

    - #### getPeriodType

          XBRLItem.PeriodType getPeriodType()

      Gets the period type.
      Returns:
        the period type

    - #### getDate

          java.lang.String getDate(int type,
                                 boolean operate)

      Gets the date.
      Parameters:
        `type` - the type
        `operate` - the operate
      Returns:
        the date

    - #### getGregorianCalendarDate

          java.util.GregorianCalendar getGregorianCalendarDate(int type)

      Gets the gregorian calendar date.
      Parameters:
        `type` - the type
      Returns:
        the gregorian calendar date

    - #### getRawDate

          java.lang.String getRawDate(int type,
                                    boolean operate)

      Gets the raw date.
      Parameters:
        `type` - the type
        `operate` - the operate
      Returns:
        the raw date

    - #### getRawDateUtil

          java.util.Date getRawDateUtil(int code)

      Gets the raw date util.
      Parameters:
        `code` - the code
      Returns:
        the raw date util

    - #### getRawGregorianCalendarDate

          java.util.GregorianCalendar getRawGregorianCalendarDate(int type)

      Gets the raw gregorian calendar date.
      Parameters:
        `type` - the type
      Returns:
        the raw gregorian calendar date

    - #### toString

          java.lang.String toString()

      To string.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        the string

    - #### getElements

          java.util.Iterator<XMLFragment> getElements()

      Gets the elements.
      Returns:
        the elements

    - #### equals

          boolean equals(java.lang.Object other)

      Equals.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the other
      Returns:
        true, if successful

    - #### hashCode

          int hashCode()

      Hash code.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        the int

    - #### clone

          MapperPeriod clone()

      Clone.
      Returns:
        the mapper period

    - #### generateNode

          org.jdom.Element generateNode(boolean relativize,
                                      java.net.URI base)
                                        throws XBRLSerializationException

      Generate node.
      Parameters:
        `relativize` - the relativize
        `base` - the base
      Returns:
        the element
      Throws:
        `XBRLSerializationException` - the XBRL serialization exception